import useListContactStore from "@/feature/messenger/store/useListContactStore";
import { profileIconSize } from "@/feature/messenger/utils/ProfileColorIcon";
import { Spinner } from "@nextui-org/react";
import { useState, useEffect } from "react";

export default function ItemsContacts() {
    const listContact = useListContactStore(state => state.listContact);
    const selectedContact = useListContactStore(state => state.selectedContact);
    const [colors, setColors] = useState<any[]>([]);
    const [loading, setLoading] = useState(true);

    useEffect(() => {
        const timer = setTimeout(() => {
            setLoading(false);
        }, 3000);

        return () => clearTimeout(timer);
    }, []);

    const profileIcon = (item: any, index: any) => {
        const finds = colors.find((color) => color.index === index);
        if (finds != undefined) {
            return finds.icon;
        }
        const icon = profileIconSize(item.nombre);
        setColors((prevColors) => [...prevColors, { icon: icon, index: index }]);
        return icon;
    }
    return (
        <>
            {listContact.length == 0 ? <>
                <div className="w-full h-full flex justify-center items-center">
                    {loading ? (
                        <Spinner size="lg" />
                    ) : (
                        <p className="text-gray-500">No hay registros</p>
                    )}
                </div>
            </> : <>
                <ul className="w-full h-[90%] overflow-y-auto overflow-x-hidden">
                    {listContact.length > 0 && listContact.map((item: any, index: any) => {
                        return (
                            <li onClick={(e) => selectedContact(e, item)} key={index} className="hover:bg-[#1c9dea] hover:bg-opacity-15 p-1 my-1 border border-gray-100 rounded-md">
                                <div className="flex justify-start items-center gap-x-4 w-fit">
                                    {profileIcon(item, index)}
                                    <div className="details gap-y-1">
                                        <h5 className="truncate text-ellipsis capitalize w-full">{item.nombre || ""}</h5>
                                        <h6>{item.celular || ""}</h6>
                                    </div>
                                </div>
                            </li>
                        )
                    })}
                </ul>
            </>}
        </>
    )
}